diff --git a/doc/Makefile b/doc/Makefile
index 1f63830..549809e 100644
--- a/doc/Makefile
+++ b/doc/Makefile
@@ -1,3 +1,7 @@
+# SPDX-FileCopyrightText: 2013-2021 Stefano Babic <sbabic@denx.de>
+#
+# SPDX-License-Identifier: GPL-2.0-only
+
 # Makefile for Sphinx documentation
 #
 
diff --git a/doc/README b/doc/README
index 5e931d6..7d9b897 100644
--- a/doc/README
+++ b/doc/README
@@ -1,3 +1,7 @@
+# SPDX-FileCopyrightText: 2013-2021 Stefano Babic <sbabic@denx.de>
+#
+# SPDX-License-Identifier: GPL-2.0-only
+
 Documentation is written in Restructured Text.
 
 To generate the documentation in other format,
diff --git a/doc/source/bindings.rst b/doc/source/bindings.rst
index 51dfc1d..9dbe458 100644
--- a/doc/source/bindings.rst
+++ b/doc/source/bindings.rst
@@ -1,3 +1,6 @@
+.. SPDX-FileCopyrightText: 2013-2021 Stefano Babic <sbabic@denx.de>
+.. SPDX-License-Identifier: GPL-2.0-only
+
 =============================================
 Language Bindings
 =============================================
diff --git a/doc/source/building-with-yocto.rst b/doc/source/building-with-yocto.rst
index 7085bfb..2572b20 100644
--- a/doc/source/building-with-yocto.rst
+++ b/doc/source/building-with-yocto.rst
@@ -1,3 +1,6 @@
+.. SPDX-FileCopyrightText: 2013-2021 Stefano Babic <sbabic@denx.de>
+.. SPDX-License-Identifier: GPL-2.0-only
+
 ==================================
 meta-swupdate: building with Yocto
 ==================================
diff --git a/doc/source/conf.py b/doc/source/conf.py
index b370272..5b41bf4 100644
--- a/doc/source/conf.py
+++ b/doc/source/conf.py
@@ -1,3 +1,7 @@
+# SPDX-FileCopyrightText: 2013 Stefano Babic <sbabic@denx.de>
+#
+# SPDX-License-Identifier: GPL-2.0-only
+#
 # -*- coding: utf-8 -*-
 #
 # SW Specifications build configuration file, created by
diff --git a/doc/source/contributing.rst b/doc/source/contributing.rst
index 7ab5574..bda277f 100644
--- a/doc/source/contributing.rst
+++ b/doc/source/contributing.rst
@@ -1,3 +1,6 @@
+.. SPDX-FileCopyrightText: 2013-2021 Stefano Babic <sbabic@denx.de>
+.. SPDX-License-Identifier: GPL-2.0-only
+
 Contributing to SWUpdate
 ========================
 
diff --git a/doc/source/encrypted_images.rst b/doc/source/encrypted_images.rst
index 1dc9744..611f3dc 100644
--- a/doc/source/encrypted_images.rst
+++ b/doc/source/encrypted_images.rst
@@ -1,3 +1,6 @@
+.. SPDX-FileCopyrightText: 2013-2021 Stefano Babic <sbabic@denx.de>
+.. SPDX-License-Identifier: GPL-2.0-only
+
 Symmetrically Encrypted Update Images
 =====================================
 
diff --git a/doc/source/handlers.rst b/doc/source/handlers.rst
index 560fa7f..6a08ad7 100644
--- a/doc/source/handlers.rst
+++ b/doc/source/handlers.rst
@@ -1,3 +1,6 @@
+.. SPDX-FileCopyrightText: 2013-2021 Stefano Babic <sbabic@denx.de>
+.. SPDX-License-Identifier: GPL-2.0-only
+
 =============================================
 Handlers
 =============================================
diff --git a/doc/source/hawkbit-setup.rst b/doc/source/hawkbit-setup.rst
index c90ea65..b90060d 100644
--- a/doc/source/hawkbit-setup.rst
+++ b/doc/source/hawkbit-setup.rst
@@ -1,3 +1,6 @@
+.. SPDX-FileCopyrightText: 2013-2021 Stefano Babic <sbabic@denx.de>
+.. SPDX-License-Identifier: GPL-2.0-only
+
 ==========================================================
 Config for hawkBit under SSL/TLS using private CA / sub CA
 ==========================================================
diff --git a/doc/source/help_and_support.rst b/doc/source/help_and_support.rst
index 7b3cfa6..2349117 100644
--- a/doc/source/help_and_support.rst
+++ b/doc/source/help_and_support.rst
@@ -1,3 +1,6 @@
+.. SPDX-FileCopyrightText: 2013-2021 Stefano Babic <sbabic@denx.de>
+.. SPDX-License-Identifier: GPL-2.0-only
+
 ================
 Help and support
 ================
diff --git a/doc/source/index.rst b/doc/source/index.rst
index cd57d95..3f83275 100644
--- a/doc/source/index.rst
+++ b/doc/source/index.rst
@@ -1,3 +1,6 @@
+.. SPDX-FileCopyrightText: 2013-2021 Stefano Babic <sbabic@denx.de>
+.. SPDX-License-Identifier: GPL-2.0-only
+
 .. _contents: Table of contents
 
 .. image:: images/SWUpdate.png
diff --git a/doc/source/licensing.rst b/doc/source/licensing.rst
index c9fa639..055875e 100644
--- a/doc/source/licensing.rst
+++ b/doc/source/licensing.rst
@@ -1,3 +1,6 @@
+.. SPDX-FileCopyrightText: 2013-2021 Stefano Babic <sbabic@denx.de>
+.. SPDX-License-Identifier: GPL-2.0-only
+
 =======
 License
 =======
diff --git a/doc/source/mongoose.rst b/doc/source/mongoose.rst
index 0333392..69ddfb7 100644
--- a/doc/source/mongoose.rst
+++ b/doc/source/mongoose.rst
@@ -1,3 +1,6 @@
+.. SPDX-FileCopyrightText: 2013-2021 Stefano Babic <sbabic@denx.de>
+.. SPDX-License-Identifier: GPL-2.0-only
+
 ====================
 Mongoose daemon mode
 ====================
diff --git a/doc/source/overview.rst b/doc/source/overview.rst
index b446ac0..6c72893 100644
--- a/doc/source/overview.rst
+++ b/doc/source/overview.rst
@@ -1,3 +1,6 @@
+.. SPDX-FileCopyrightText: 2013-2021 Stefano Babic <sbabic@denx.de>
+.. SPDX-License-Identifier: GPL-2.0-only
+
 =======================================
 Software Management on embedded systems
 =======================================
diff --git a/doc/source/previous-releases.rst b/doc/source/previous-releases.rst
index 51ff054..55055ea 100644
--- a/doc/source/previous-releases.rst
+++ b/doc/source/previous-releases.rst
@@ -1,3 +1,6 @@
+.. SPDX-FileCopyrightText: 2013-2021 Stefano Babic <sbabic@denx.de>
+.. SPDX-License-Identifier: GPL-2.0-only
+
 ===================================
 Documentation for previous releases
 ===================================
diff --git a/doc/source/progress.rst b/doc/source/progress.rst
index 465f931..fa0b527 100644
--- a/doc/source/progress.rst
+++ b/doc/source/progress.rst
@@ -1,3 +1,6 @@
+.. SPDX-FileCopyrightText: 2013-2021 Stefano Babic <sbabic@denx.de>
+.. SPDX-License-Identifier: GPL-2.0-only
+
 Getting information on running update
 =====================================
 
diff --git a/doc/source/roadmap.rst b/doc/source/roadmap.rst
index a575780..dc7d547 100644
--- a/doc/source/roadmap.rst
+++ b/doc/source/roadmap.rst
@@ -1,3 +1,6 @@
+.. SPDX-FileCopyrightText: 2013-2021 Stefano Babic <sbabic@denx.de>
+.. SPDX-License-Identifier: GPL-2.0-only
+
 ==================
 Project's road-map
 ==================
diff --git a/doc/source/scenarios.rst b/doc/source/scenarios.rst
index c1140c3..718f95c 100644
--- a/doc/source/scenarios.rst
+++ b/doc/source/scenarios.rst
@@ -1,3 +1,6 @@
+.. SPDX-FileCopyrightText: 2013-2021 Stefano Babic <sbabic@denx.de>
+.. SPDX-License-Identifier: GPL-2.0-only
+
 Update strategy examples
 ========================
 
diff --git a/doc/source/signed_images.rst b/doc/source/signed_images.rst
index 3b61483..581196d 100644
--- a/doc/source/signed_images.rst
+++ b/doc/source/signed_images.rst
@@ -1,3 +1,6 @@
+.. SPDX-FileCopyrightText: 2013-2021 Stefano Babic <sbabic@denx.de>
+.. SPDX-License-Identifier: GPL-2.0-only
+
 Update images from verified source
 ==================================
 
diff --git a/doc/source/suricatta.rst b/doc/source/suricatta.rst
index 9fa068d..6c8715c 100644
--- a/doc/source/suricatta.rst
+++ b/doc/source/suricatta.rst
@@ -1,3 +1,6 @@
+.. SPDX-FileCopyrightText: 2013-2021 Stefano Babic <sbabic@denx.de>
+.. SPDX-License-Identifier: GPL-2.0-only
+
 =====================
 Suricatta daemon mode
 =====================
diff --git a/doc/source/sw-description.rst b/doc/source/sw-description.rst
index 7100898..6c186da 100644
--- a/doc/source/sw-description.rst
+++ b/doc/source/sw-description.rst
@@ -1,3 +1,6 @@
+.. SPDX-FileCopyrightText: 2013-2021 Stefano Babic <sbabic@denx.de>
+.. SPDX-License-Identifier: GPL-2.0-only
+
 =================================================
 SWUpdate: syntax and tags with the default parser
 =================================================
diff --git a/doc/source/swupdate-client.rst b/doc/source/swupdate-client.rst
index a454979..2eb77d6 100644
--- a/doc/source/swupdate-client.rst
+++ b/doc/source/swupdate-client.rst
@@ -1,3 +1,6 @@
+.. SPDX-FileCopyrightText: 2013-2021 Stefano Babic <sbabic@denx.de>
+.. SPDX-License-Identifier: GPL-2.0-only
+
 swupdate-client
 ===============
 
diff --git a/doc/source/swupdate-hawkbitcfg.rst b/doc/source/swupdate-hawkbitcfg.rst
index dd7199d..0a35661 100644
--- a/doc/source/swupdate-hawkbitcfg.rst
+++ b/doc/source/swupdate-hawkbitcfg.rst
@@ -1,3 +1,6 @@
+.. SPDX-FileCopyrightText: 2013-2021 Stefano Babic <sbabic@denx.de>
+.. SPDX-License-Identifier: GPL-2.0-only
+
 swupdate-hawkbitcfg
 ===================
 
diff --git a/doc/source/swupdate-ipc.rst b/doc/source/swupdate-ipc.rst
index 3c45ab3..9160874 100644
--- a/doc/source/swupdate-ipc.rst
+++ b/doc/source/swupdate-ipc.rst
@@ -1,3 +1,6 @@
+.. SPDX-FileCopyrightText: 2013-2021 Stefano Babic <sbabic@denx.de>
+.. SPDX-License-Identifier: GPL-2.0-only
+
 ===================================
 SWUpdate: API for external programs
 ===================================
diff --git a/doc/source/swupdate-progress.rst b/doc/source/swupdate-progress.rst
index 2f21891..d667cb6 100644
--- a/doc/source/swupdate-progress.rst
+++ b/doc/source/swupdate-progress.rst
@@ -1,3 +1,6 @@
+.. SPDX-FileCopyrightText: 2013-2021 Stefano Babic <sbabic@denx.de>
+.. SPDX-License-Identifier: GPL-2.0-only
+
 swupdate-progress
 =================
 
diff --git a/doc/source/swupdate-sendtohawkbit.rst b/doc/source/swupdate-sendtohawkbit.rst
index 02e00d1..03159e8 100644
--- a/doc/source/swupdate-sendtohawkbit.rst
+++ b/doc/source/swupdate-sendtohawkbit.rst
@@ -1,3 +1,6 @@
+.. SPDX-FileCopyrightText: 2013-2021 Stefano Babic <sbabic@denx.de>
+.. SPDX-License-Identifier: GPL-2.0-only
+
 swupdate-sendtohawkbit
 ======================
 
diff --git a/doc/source/swupdate-sysrestart.rst b/doc/source/swupdate-sysrestart.rst
index 87eae52..7148d37 100644
--- a/doc/source/swupdate-sysrestart.rst
+++ b/doc/source/swupdate-sysrestart.rst
@@ -1,3 +1,6 @@
+.. SPDX-FileCopyrightText: 2013-2021 Stefano Babic <sbabic@denx.de>
+.. SPDX-License-Identifier: GPL-2.0-only
+
 swupdate-sysrestart
 ===================
 
diff --git a/doc/source/swupdate.rst b/doc/source/swupdate.rst
index 61663e1..7bd6c92 100644
--- a/doc/source/swupdate.rst
+++ b/doc/source/swupdate.rst
@@ -1,3 +1,6 @@
+.. SPDX-FileCopyrightText: 2013-2021 Stefano Babic <sbabic@denx.de>
+.. SPDX-License-Identifier: GPL-2.0-only
+
 =============================================
 SWUpdate: software update for embedded system
 =============================================